	list	p=16f84
	include "P16F84A.inc"
	__config	_RC_OSC & _WDT_OFF & _PWRTE_ON
;  / (. 16)
;
ANODE	equ	PORTA
bFig1	equ	3	;RA3 (. 2)
bFig2	equ	2	;RA2 (. 1)
bFig3	equ	1	;RA1 (. 18)
bFig4	equ	0	;RA0 (. 17)
mANODE	equ	(1<<bFig1)|(1<<bFig2)|(1<<bFig3)|(1<<bFig4)
DCD	equ	PORTB
mDCD	equ	B'00001111'	;RB0-RB3 (. 6-9)
;
SENSORS	equ	PORTB
bKey	equ	6	;RB6 (. 12)
bSEN1	equ	5	;RB5 (. 11)
bSEN2	equ	4	;RB4 (. 10)
mSEN1	equ	1<<bSEN1
mSEN2	equ	1<<bSEN2
mSENS	equ	mSEN1+mSEN2

MaxInt	equ	(.31*4)-1
; (. 17)
	cblock	H'0C'
	W_copy	
	STATUS_copy
	FSR_copy
	SensPos
	FigPtr
	Fig1
	Fig2
	Fig3
	Fig4
	FigSel
	IntCtr	; 
	Alarm		;  1->0
	endc
;  
Pos0	equ	0
Pos1	equ	mSEN1
Pos2	equ	mSENS
Pos3	equ	mSEN2	
;
;  (. 7)
NODE	macro	pp1,nn1,pp2,nn2,pp3,nn3
	local	NO
NO	movfw	SENSORS
	andlw	mSENS
	movwf	SensPos
	xorlw	pp1
	BZ	nn1
	movfw	SensPos
	xorlw	pp2
	BZ	nn2
	movfw	SensPos
	xorlw	pp3
	BZ	nn3
	goto	NO
	endm	
INCR	macro	Fig
	local	Lab
	movfw	Fig
	addlw	-9
	BZ	Lab
	incf	Fig,f
	return
Lab	clrf	Fig
	endm
DECR	macro	Fig
	local	Lab
	movf	Fig,f
	BZ	Lab
	decf	Fig,f
	return
Lab	movlw	9
	movwf	Fig
	endm
SetLeft	macro					
	movlw	Fig1
	movwf	FigPtr
	movlw	B'00001000'
	movwf	FigSel
	endm
;  
	org	0
	goto	START
	org	4
;  
;   (. 19)
T0SERV	movwf	W_copy
	movf	STATUS,w
	movwf	STATUS_copy
	movf	FSR,w
	movwf	FSR_copy
	;
	decfsz	IntCtr,f
	goto	Proceed
	movlw	MaxInt
	movwf	IntCtr
	btfss	SENSORS,bKey
	goto	Proceed
	btfsc	FigSel, bFig2
	call	INCR1
	btfsc	FigSel, bFig3
	call	INCR2
	btfsc	FigSel, bFig4
	call	INCR3
	btfsc	FigSel, bFig1
	call	INCR4
Proceed	
	;
	clrf	ANODE
	movfw	FigPtr
	movwf	FSR
	movfw	INDF
	iorwf Alarm,w
	movwf	DCD
	movfw	FigSel
	movwf	ANODE
	incf	FigPtr,f
	bcf	STATUS,C		
	rrf	FigSel,f
	btfss	STATUS,C
	goto	ENDINT
	SetLeft
ENDINT	movf	FSR_copy,w
	movwf	FSR
	movf	STATUS_copy,w
	movwf	STATUS
	swapf	W_copy,f
	swapf	W_copy,w
	bcf	INTCON,T0IF
	retfie
	;
INCR1	INCR	Fig1
	return
INCR2	INCR	Fig2
	return
INCR3	INCR	Fig3
	return
INCR4	INCR	Fig4
	return

; (. 18)
START	clrf	ANODE
	bsf	STATUS,RP0
	clrf	TRISA
	movlw	B'01110000'		
	movwf	TRISB
	bsf	OPTION_REG,NOT_RBPU ; ""
	bcf	OPTION_REG,T0CS
	bcf	STATUS,RP0
	SetLeft
	clrf	Fig1
	clrf	Fig2
	clrf	Fig3
	clrf	Fig4
	movlw	MaxInt
	movwf	IntCtr
	clrf	Alarm
	bsf	INTCON,T0IE
	bsf	INTCON,GIE
;  (. 10)
ND0	NODE	Pos1,ND1,Pos3,ND4,Pos2,ND0
ND1	NODE	Pos2,ND2,Pos0,ND0,Pos3,ND0
ND2	NODE	Pos3,ND3,Pos1,ND1,Pos0,ND0
ND3	NODE	Pos0,ND3A,Pos2,ND2,Pos1,ND0
ND3A	bcf	INTCON,GIE
	call	ADD1
	bsf	INTCON,GIE
	clrf	Alarm
	goto	ND0
ND4	NODE	Pos2,ND5,Pos0,ND0,Pos1,ND0
ND5	NODE	Pos1,ND6,Pos3,ND4,Pos0,ND0
ND6	NODE	Pos0,ND6S,Pos2,ND5,Pos3,ND0
ND6S	bcf	INTCON,GIE
	call	SUBT1
	bsf	INTCON,GIE
	clrf	Alarm
	movf	Fig1,w
	addwf	Fig2,w
	addwf	Fig3,w
	addwf	Fig4,w
	btfsc	STATUS,Z
	bsf	Alarm,7
	goto	ND0
; (. 13)
ADD1	INCR	Fig4
	INCR	Fig3
	INCR	Fig2
	INCR	Fig1
	return
SUBT1	DECR	Fig4
	DECR	Fig3
	DECR	Fig2
	DECR	Fig1
	return	

	end	
